/* Simple KWIC generator, uses stdin/stdout only,
   all space statically allocated. */

#include <stdio.h>
#include <strings.h>

#define SYMLEN 80

#define BUFSIZE 300000

char arr[BUFSIZE];

int longest = 0;

compare_names(n1, n2)
char *n1, *n2;
{
    return strcmp(n1+SYMLEN/2, n2+SYMLEN/2);
}

main()
{
    int i = 0, j, maxi, offset, lastoffset;
    char name[SYMLEN], *pos;

    for (i = 0; i < BUFSIZE; ++i) {
	arr[i] = ' ';
    }
    i = 0;
    while (gets(name) != NULL) {
	/* Cut off anything excessively long. */
	name[SYMLEN/2] = '\0';
	if (strlen(name) > longest) longest = strlen(name);
	/* Put out the name undisplaced. */
	strcpy(&(arr[(i++)*SYMLEN+SYMLEN/2]), name);
	for (j = 0; name[j] != '\0'; ++j) {
	    if (name[j] == '-') {
		/* Put out the name shifted left by position of hyphen. */
		strcpy(&(arr[(i++)*SYMLEN+SYMLEN/2-j-1]), name);
	    }
	}
    }
    maxi = i;
    qsort(arr, maxi, SYMLEN, compare_names); 
    for (i = 0; i < maxi; ++i) {
	puts(&(arr[i*SYMLEN+SYMLEN/2-longest]));
    }
}
