/* Image family stuff. */

/* Each image can stash a number of rendering techniques. */

typedef struct a_image {
    int w, h;
    int minw, minh;
    int maxw, maxh;
    Pixmap mono;
    Pixmap colr;
    Pixmap mask;
    XFontStruct *font;
    char monochar;
    char maskchar;
    int istile;
} Image;

typedef struct a_image_family {
    char *name;
    int numsizes;
    Image images[10];
} ImageFamily;

Image *best_image();
